﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.core.geom.Lines3D;
	import org.papervision3d.core.geom.renderables.Line3D;
	import org.papervision3d.core.geom.renderables.Vertex3D;
	import org.papervision3d.core.math.Sphere3D;
	import org.papervision3d.core.proto.MaterialObject3D;
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.ColorMaterial;
	import org.papervision3d.materials.WireframeMaterial;
	import org.papervision3d.materials.shadematerials.FlatShadeMaterial;
	import org.papervision3d.materials.special.CompositeMaterial;
	import org.papervision3d.materials.special.LineMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.DisplayObject3D;
	import org.papervision3d.objects.primitives.Cube;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	
	public class Suiveur extends Sprite
	{
		
		private var viewport:Viewport3D;
		private var scene3d:Scene3D;
		private var camera:Camera3D;		
		private var renderer:BasicRenderEngine;
		private var matCom:CompositeMaterial;
		
		
		private var target:DisplayObject3D = DisplayObject3D.ZERO;
		private var s:Sphere;
		private var c:Cube;
		
		
		private var index:int = 0;
		private var stack:Array;
		private var l3d:Lines3D;
		private var matLine:LineMaterial;
		private var i:int;
		
		private var posx:int = 0;
		private var posy:int = 0;
		
		public function Suiveur()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			
		}
		
		private function addedHandler(e:Event):void
		{		
			init();
		}
		
		
		private function init()
		{
			scene3d = new Scene3D();
			camera = new Camera3D();
			camera.zoom = 100;
			
			renderer = new BasicRenderEngine();
			viewport = new Viewport3D(stage.stageWidth, stage.stageHeight);
			addChild(viewport);
			
			scene3d.addChild(target);
			
			var light:PointLight3D = new PointLight3D();
			var fsm:FlatShadeMaterial = new FlatShadeMaterial(light, 0xffffff, 0xdddddd);
			fsm.doubleSided = true;
			
			var matList:MaterialsList = new MaterialsList();
			
			var m1:ColorMaterial = new ColorMaterial(0x333333, 1);
			m1.doubleSided = true;
			matList.addMaterial( m1, "all");
			//
			
			s = new Sphere(fsm,3000,24,20);
			c = new Cube(matList,3000,3000,3000);
			
			//scene3d.addChild(s);
			
			addEventListener(Event.ENTER_FRAME, enterHandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
		}
		
		
		
		private function downHandler(e:MouseEvent):void
		{
			
			stack = new Array;
			index = 0;
			
			matLine = new LineMaterial(0x999999,1);
			l3d = new Lines3D(matLine);
			
			scene3d.addChild(l3d);
			
			
			stage.addEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
		}
		
		private function moveHandler(e:MouseEvent):void
		{
			stage.addEventListener(MouseEvent.MOUSE_UP, upHandler);
			index+= 1;
			
			i = index-1;
			
			var ptv:Vertex3D = circle((stage.stageWidth/2 - mouseX)/100,(stage.stageHeight/2 - mouseY)/100, index/4);
			
			stack.push(new Array(ptv.x, ptv.y, ptv.z))
			
			if(Math.abs(e.stageX - stack[stack.length-1][0]) < 4 || Math.abs(e.stageY - stack[stack.length-1][1]) < 4){
				//stack.pop();
			}
			
			
			trace("stack" + stack.length);
			trace("i" + i);
			
			
			if(stack.length > 2) l3d.addNewLine(3,stack[i-1][0], stack[i-1][1], stack[i-1][2], stack[i][0], stack[i][1], stack[i][2]);
			
			
		}
		
		private function upHandler(e:MouseEvent):void
		{
			stage.removeEventListener(MouseEvent.MOUSE_MOVE, moveHandler);
		}
		
		
		private function enterHandler(e:Event):void
		{
			var pt:Vertex3D = circle((stage.stageWidth/2 - mouseX)/100,(stage.stageHeight/2 - mouseY)/100, index+1);
			camera.x = -pt.x;			
			camera.y = -pt.y;
			camera.z = -pt.z;
			
			camera.target = target;
			renderer.renderScene(scene3d, camera, viewport);
			
		}
		private function circle(_radians:Number, _radians2:Number, _radius:Number):Vertex3D
		{
			_radians -= Math.PI/2;
			_radians2 -= Math.PI/2;
			var x:Number = _radius * Math.cos(_radians);
			var y:Number = _radius * Math.cos(_radians2);
			var z:Number = _radius * Math.sin(_radians);
			return new Vertex3D(x,y,z);
		}
	}
}